'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('babel-polyfill');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _Reaction = require('./Reaction');

var _Reaction2 = _interopRequireDefault(_Reaction);

var _store = require('./store');

var _store2 = _interopRequireDefault(_store);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Reaction = function () {
  function Reaction() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Reaction);

    this.options = options;
  }

  _createClass(Reaction, [{
    key: 'render',
    value: function render(container, options) {
      var node = null;
      container = container || this.options.container;

      if (!container) {
        throw new Error('Container is required: ' + container);
      }
      if (!(container instanceof HTMLElement)) {
        node = document.getElementById(container);
        if (!node) {
          throw new Error('Container not found, document.getElementById: ' + container);
        }
      } else {
        node = container;
      }
      return (0, _reactDom.render)(_react2.default.createElement(_Reaction2.default, _extends({}, this.options, options)), node);
    }
  }, {
    key: 'component',
    get: function get() {
      var _this = this;

      return function (props) {
        return _react2.default.createElement(_Reaction2.default, _extends({}, _this.options, props));
      };
    }
  }]);

  return Reaction;
}();

module.exports = Reaction;