'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var parse = exports.parse = function parse(queryString) {
  var query = {};
  var pairs = (queryString[0] === '?' ? queryString.substr(1) : queryString).split('&');
  for (var i = 0; i < pairs.length; i++) {
    var pair = pairs[i].split('=');
    query[decodeURIComponent(pair[0])] = decodeURIComponent(pair[1] || '');
  }
  return query;
};
var stringify = exports.stringify = function stringify(params) {
  var esc = encodeURIComponent;
  var query = Object.keys(params).map(function (k) {
    return esc(k) + '=' + esc(params[k]);
  }).join('&');
  return query;
};